(function () {

    $(document).on('ready', function () {
        $('#Plugins_EZupPlugin_username_value').val('');
    });

    $('body').on('click', '#field_e8b3d57813616bf196d02124022781ad button', function () {

        var username = $('#Plugins_EZupPlugin_username_value').val().trim();

        if (!username) {
            alertify.error('Please, input username to generate valid Standalone Upload link');
            return;
        }

        var expiration = parseInt($('#Plugins_EZupPlugin_expiration_value').val());

        if (isNaN(expiration)) {
            expiration = 0;
        }

        $.ajax({
            cache: false,
            url: EZupPluginApiUrl,
            method: 'POST',
            async: false,
            data: attachCSRFToken({username: username, expiration: expiration}),
            beforeSend: function () {
            },
            success: function (data) {

                var success = false;

                var error = 'Could not generate Standalone Upload link. Make sure the plugin is activated';

                try {

                    var result = $.parseJSON(data);

                    if (result.success === true) {

                        success = true;

                        copyStringToClipboard(result.link);

                        alertify.success('The link was successfully generated and put to your clipboard');

                    } else if (result.success === false) {
                        error = 'Could not generate Standalone Upload link. ' + result.error;
                    }

                } catch (e) {
                }

                if (!success) {
                    alertify.error(error);
                }

            },
            error: function () {
                alertify.error('Could not generate Standalone Upload link. Make sure plugin is active');
            }
        });

    });

    function copyStringToClipboard(str) {
        // Create new element
        var el = document.createElement('textarea');
        // Set value (string to be copied)
        el.value = str;
        // Set non-editable to avoid focus and move outside of view
        el.setAttribute('readonly', '');
        el.style = {position: 'absolute', left: '-9999px'};
        document.body.appendChild(el);
        // Select text inside element
        el.select();
        // Copy text to clipboard
        document.execCommand('copy');
        // Remove temporary element
        document.body.removeChild(el);
    }


})();

