(function () {

    $(document).ready(function () {

        $('.modal-footer').remove();

        /**
         * override resizeUploadHandler function
         */
        resizeUploadHandler = function () {

            var uploadBody = $('.plupload_container');
            var metadataContainer = $('#metadata .inner');
            var height = window.innerHeight;

            uploadBody.css({height: (height - 55) + 'px'});
            metadataContainer.css({height: (height - 115) + 'px'});

        };

        /**
         * override startUploader function
         */
        startUploader = function () {

            var error = 'Could not create upload folder';

            /**
             * make ajax request to plugin url with action=mkdir to create upload folder in volume root
             */
            $.ajax({
                cache: false,
                url: window.location.href + '&action=mkdir' + (typeof YII_CSRF_TOKEN != 'undefined' ? '&YII_CSRF_TOKEN=' + YII_CSRF_TOKEN : ''),
                method: 'GET',
                async: false,
                beforeSend: function () {
                },
                success: function (data) {

                    var success = false;

                    /**
                     * try to json-decode result
                     * if json is valid - proceed reading it
                     */
                    try {

                        var result = $.parseJSON(data);

                        /**
                         * if we are successful - replace getUploadUrl function
                         * so that it uses url, passed in result to run plupload
                         * and execute performActualUpload function
                         */
                        if (result.success === true) {

                            success = true;

                            getUploadUrl = function () {
                                return result.url + '&chunk=1' + (typeof YII_CSRF_TOKEN != 'undefined' ? '&YII_CSRF_TOKEN=' + YII_CSRF_TOKEN : '')
                            };

                            performActualUpload();

                        } else if (result.error) {
                            error = result.error;
                        }

                    } catch (e) {
                    }

                    /**
                     * if success if false - show alert
                     */
                    if (!success) {
                        alertify.error(error);
                    }

                },
                error: function () {
                    alertify.error(error);
                }
            });

        };

        resizeUploadHandler();

        $('#page').css('visibility', 'visible');

        $('body').show().on('click', '.volume-radio', function () {
            window.location.href = $(this).attr('url');
        });

    });


})();

